% Julie Sandberg
% Aero 624 Celestial Mechanics
% Final Project
% This script calculates the position and velocity vectors for given 
% orbital elements

function vectors = orbital_to_inertial(a,e,Omega,i,w,f,M0,t)

global myu p e_vect;

format long

n = sqrt(myu/a^3);   

%Calculate E using Newton's Method
E = Kepler(e,M0);
E = double(E);

r = a*(1-e*cos(E));
r = double(r);

x = a*(cos(E) - e);
x = double(x);
y = a*sqrt(1-e^2)*sin(E);
y = double(y);

vx = -(sqrt(myu*a)*sin(E))/r;
vx = double(vx);
vy = (sqrt(myu*a*(1-e^2))*cos(E))/r;
vy = double(vy);

% Rotation Matrix
R3_w = [cos(w) sin(w) 0;...
        -sin(w) cos(w) 0;...
          0      0     1];
R3_w = double(R3_w);

R1_i = [1 0 0;...
        0 cos(i) sin(i);...
        0 -sin(i) cos(i)];
R1_i = double(R1_i);

R3_Omega = [cos(Omega) sin(Omega)  0;...
            -sin(Omega) cos(Omega) 0;...
              0          0         1];
R3_Omega = double(R3_Omega);

Roi = R3_w*R1_i*R3_Omega;
Roi = double(Roi);

XYZ = Roi'*[x; y; 0];
XYZ = double(XYZ);

XYZ_dot = Roi'*[vx; vy; 0];
XYZ_dot = double(XYZ_dot);

r = [XYZ(1) XYZ(2) XYZ(3)];
r = double(r);

v = [XYZ_dot(1) XYZ_dot(2) XYZ_dot(3)];
v = double(v);

vectors = [r; v];