% Julie Sandberg
% Aero 624 Celestial Mechanics
% Final Project
% This function gives the equations of motion for two bodies

function RV = TwoBody(t,states)

global myu; 

format long

r = states(1:3);
r = double(r);
v = states(4:6);
v = double(v);

% Calculate Perturbing Force for Cannonball Drag
rho = 1.225*exp(-(norm(r)-6378)/16);
rho = double(rho);
m = 70;         % kg
CD = 1.2;
A = 10;         % m^2
ad = -1/2*rho*(CD*A)*(norm(v)*v)/m;
ad1 = double(ad);
% ad = ad1

% Calculate Perturbing Force for J2 Oblateness
J2 = 1.0826e-3;         % Earth oblateness
rE = 6378;              % km
x = r(1);
y = r(2);
z = r(3);
ad2 = -(3*myu*J2*rE^2)/(2*norm(r)^7)*[x*(x^2+y^2-4*z^2); y*(x^2+y^2-4*z^2); z*(3*x^2+3*y^2-2*z^2)];
% ad = ad2

ad = ad1 + ad2

a = -myu*r/(norm(r))^3+ad;
a = double(a);

RV = [v(1); v(2); v(3); a(1); a(2); a(3)];