% Julie Sandberg
% Aero 624 Celestial Mechanics
% Homework 2, Program 1
% This script calculates the orbital elements given initial position and
% velocity vectors

function elements = inertial_to_orbital(r,v,t0)

global myu p e_vect;

format long

h = cross(r,v);                                 % Angular momentum
h = double(h);

i = acos(h(3)/norm(h));                         % Inclination (deg)
i = double(i);

a = myu/(2*myu/norm(r)-(norm(v))^2);            % Semi-major axis
a = double(a);

Omega = asin(h(1)/(sin(i)*norm(h)));            % Right Ascension of ascending node
Omega = double(Omega);

e_vect = 1/myu*(cross(v,h) - (myu*r)/norm(r));   % Eccentricity vector
e_vect = double(e_vect);

e = norm(e_vect);                               % Eccentricity
e = double(e);

sigma = (r(1)*v(1)+r(2)*v(2)+r(3)*v(3))/sqrt(myu);
E = atan2((sigma/sqrt(a)),(1-norm(r)/a));
M = E-e*sin(E);
M = double(M);
% f = 2*atan(sqrt((1+e)/(1-e))*(sin(E))/(1+cos(E)+eps));   % True anomaly       
f = 2*atan(sqrt((1+e)/(1-e))*tan(E/2));                    % True anomaly (this eqn doesn't give singularity)
f = double(f)+eps;

% Rotation Matrix
% R3_w = [cos(w) sin(w) 0;...
%         -sin(w) cos(w) 0;...
%           0      0     1]
% 
% R1_i = [1 0 0;...
%         0 cos(i) sin(i);...
%         0 -sin(i) cos(i)]
% 
% R3_Omega = [cos(Omega) sin(Omega)  0;...
%             -sin(Omega) cos(Omega) 0;...
%               0          0         1]

% Roi = R3_w*R1_i*R3_Omega


% w1 = atan2((C13)/(C23))
% Alternative method: Use the fact that Roi*e_vect = [e 0 0] and solve for
% w in the generalized (non-numeric) rotation matrix
% Solve using Roi matrix on Slide 15 of Ch. 2 Part 2 Aero 423 Class Notes
% From second row of Roi matrix,
w = -atan((-sin(Omega)*cos(i)*e_vect(1) + cos(Omega)*cos(i)*e_vect(2) + sin(i)*e_vect(3))/(-cos(Omega)*e_vect(1) - sin(Omega)*e_vect(2)));
w = double(w);

elements = [a,e,i,w,Omega,M,f];